diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index cbd761ad935..2d25f50ebe2 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -949,8 +949,11 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
         struct list *entry, IDirectInputEffect **out);
 
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    unix_joystick_init,
     NULL,
     NULL,
     unix_joystick_ff_set_autocenter,
@@ -1097,18 +1100,11 @@ static unsigned short get_joystick_index(REFGUID guid)
 static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
 {
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
-    DWORD i;
     IOHIDDeviceRef device;
     JoystickImpl* newDevice;
     char name[MAX_PATH];
-    HRESULT hr;
-    LPDIDATAFORMAT df = NULL;
     unsigned short index;
-    int idx = 0;
-    int axis_map[8]; /* max axes */
-    int slider_count = 0;
     int joystick_devices_count;
-    FFCAPABILITIES ffcaps;
     WORD vendor_id, product_id;
 
     TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
@@ -1121,6 +1117,7 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
         return DIERR_DEVICENOTREG;
 
     device = get_device_ref(index);
+    get_osx_device_name(index, name, MAX_PATH);
     vendor_id = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
     product_id = get_device_property_long(device, CFSTR(kIOHIDProductIDKey));
 
@@ -1135,19 +1132,39 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 
     newDevice->id = index;
 
+    *out = &newDevice->generic;
+    return DI_OK;
+}
+
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    IOHIDDeviceRef device;
+    LPDIDATAFORMAT df = NULL;
+    FFCAPABILITIES ffcaps;
+    char name[MAX_PATH];
+    HRESULT hr;
+    DWORD i;
+    int idx = 0;
+    int axis_map[8]; /* max axes */
+    int slider_count = 0;
+
+    device = get_device_ref(This->id);
+
     /* get the device name */
-    get_osx_device_name(index, name, MAX_PATH);
+    get_osx_device_name(This->id, name, MAX_PATH);
     TRACE("Name %s\n",name);
 
     /* copy the device name */
-    newDevice->generic.name = HeapAlloc(GetProcessHeap(),0,strlen(name) + 1);
-    strcpy(newDevice->generic.name, name);
+    This->generic.name = HeapAlloc(GetProcessHeap(), 0, strlen(name) + 1);
+    strcpy(This->generic.name, name);
 
-    list_init(&newDevice->generic.ff_effects);
-    if(get_ff(device, &newDevice->ff) == S_OK){
-        newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
+    list_init(&This->generic.ff_effects);
+    if (get_ff(device, &This->ff) == S_OK)
+    {
+        This->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
-        hr = FFDeviceGetForceFeedbackCapabilities(newDevice->ff, &ffcaps);
+        hr = FFDeviceGetForceFeedbackCapabilities(This->ff, &ffcaps);
         if(SUCCEEDED(hr)){
             TRACE("FF Capabilities:\n");
             TRACE("\tsupportedEffects: 0x%x\n", (unsigned int)ffcaps.supportedEffects);
@@ -1165,34 +1182,35 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
             TRACE("\tplaybackCapacity: %u\n", (unsigned int)ffcaps.playbackCapacity);
         }
 
-        hr = FFDeviceSendForceFeedbackCommand(newDevice->ff, FFSFFC_RESET);
+        hr = FFDeviceSendForceFeedbackCommand(This->ff, FFSFFC_RESET);
         if(FAILED(hr))
             WARN("FFDeviceSendForceFeedbackCommand(FFSFFC_RESET) failed: %08x\n", hr);
 
-        hr = FFDeviceSendForceFeedbackCommand(newDevice->ff, FFSFFC_SETACTUATORSON);
+        hr = FFDeviceSendForceFeedbackCommand(This->ff, FFSFFC_SETACTUATORSON);
         if(FAILED(hr))
             WARN("FFDeviceSendForceFeedbackCommand(FFSFFC_SETACTUATORSON) failed: %08x\n", hr);
     }
 
     memset(axis_map, 0, sizeof(axis_map));
-    get_osx_device_elements(newDevice, axis_map);
+    get_osx_device_elements(This, axis_map);
 
-    TRACE("%i axes %i buttons %i povs\n",newDevice->generic.devcaps.dwAxes,newDevice->generic.devcaps.dwButtons,newDevice->generic.devcaps.dwPOVs);
+    TRACE("%i axes %i buttons %i povs\n", This->generic.devcaps.dwAxes, This->generic.devcaps.dwButtons,
+            This->generic.devcaps.dwPOVs);
 
-    if (newDevice->generic.devcaps.dwButtons > 128)
+    if (This->generic.devcaps.dwButtons > 128)
     {
-        WARN("Can't support %d buttons. Clamping down to 128\n", newDevice->generic.devcaps.dwButtons);
-        newDevice->generic.devcaps.dwButtons = 128;
+        WARN("Can't support %d buttons. Clamping down to 128\n", This->generic.devcaps.dwButtons);
+        This->generic.devcaps.dwButtons = 128;
     }
 
     /* Create copy of default data format */
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto FAILED;
     memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
 
-    df->dwNumObjs = newDevice->generic.devcaps.dwAxes + newDevice->generic.devcaps.dwPOVs + newDevice->generic.devcaps.dwButtons;
+    df->dwNumObjs = This->generic.devcaps.dwAxes + This->generic.devcaps.dwPOVs + This->generic.devcaps.dwButtons;
     if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto FAILED;
 
-    for (i = 0; i < newDevice->generic.devcaps.dwAxes; i++)
+    for (i = 0; i < This->generic.devcaps.dwAxes; i++)
     {
         int wine_obj = -1;
         BOOL has_ff  = FALSE;
@@ -1200,31 +1218,31 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
         {
             case kHIDUsage_GD_X:
                 wine_obj = 0;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_X);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_X);
                 break;
             case kHIDUsage_GD_Y:
                 wine_obj = 1;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Y);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Y);
                 break;
             case kHIDUsage_GD_Z:
                 wine_obj = 2;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Z);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_Z);
                 break;
             case kHIDUsage_GD_Rx:
                 wine_obj = 3;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RX);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RX);
                 break;
             case kHIDUsage_GD_Ry:
                 wine_obj = 4;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RY);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RY);
                 break;
             case kHIDUsage_GD_Rz:
                 wine_obj = 5;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RZ);
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_RZ);
                 break;
             case kHIDUsage_GD_Slider:
                 wine_obj = 6 + slider_count;
-                has_ff = (newDevice->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_SLIDER(slider_count));
+                has_ff = (This->ff != 0) && osx_axis_has_ff(&ffcaps, FFJOFS_SLIDER(slider_count));
                 slider_count++;
                 break;
         }
@@ -1237,52 +1255,47 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
         ++idx;
     }
 
-    for (i = 0; i < newDevice->generic.devcaps.dwPOVs; i++)
+    for (i = 0; i < This->generic.devcaps.dwPOVs; i++)
     {
         memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 8], df->dwObjSize);
         df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_POV;
     }
 
-    for (i = 0; i < newDevice->generic.devcaps.dwButtons; i++)
+    for (i = 0; i < This->generic.devcaps.dwButtons; i++)
     {
         memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
         df->rgodf[idx  ].pguid = &GUID_Button;
         df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
     }
-    newDevice->generic.base.data_format.wine_df = df;
+    This->generic.base.data_format.wine_df = df;
 
     /* initialize default properties */
-    get_osx_device_elements_props(newDevice);
+    get_osx_device_elements_props(This);
 
-    newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
-    newDevice->generic.devcaps.dwFlags |= DIDC_ATTACHED;
-    if (newDevice->generic.base.dinput->dwVersion >= 0x0800)
-        newDevice->generic.devcaps.dwDevType = DI8DEVTYPE_JOYSTICK | (DI8DEVTYPEJOYSTICK_STANDARD << 8);
-    else
-        newDevice->generic.devcaps.dwDevType = DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_TRADITIONAL << 8);
-    newDevice->generic.devcaps.dwFFSamplePeriod = 0;
-    newDevice->generic.devcaps.dwFFMinTimeResolution = 0;
-    newDevice->generic.devcaps.dwFirmwareRevision = 0;
-    newDevice->generic.devcaps.dwHardwareRevision = 0;
-    newDevice->generic.devcaps.dwFFDriverVersion = 0;
+    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
+    This->generic.devcaps.dwFlags |= DIDC_ATTACHED;
+    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
+    This->generic.devcaps.dwFFSamplePeriod = 0;
+    This->generic.devcaps.dwFFMinTimeResolution = 0;
+    This->generic.devcaps.dwFirmwareRevision = 0;
+    This->generic.devcaps.dwHardwareRevision = 0;
+    This->generic.devcaps.dwFFDriverVersion = 0;
 
     if (TRACE_ON(dinput)) {
-        TRACE("allocated device %p\n", newDevice);
-        _dump_DIDEVCAPS(&newDevice->generic.devcaps);
+        TRACE("allocated device %p\n", This);
+        _dump_DIDEVCAPS(&This->generic.devcaps);
     }
 
-    *out = &newDevice->generic;
     return DI_OK;
 
 FAILED:
     hr = DIERR_OUTOFMEMORY;
-    if (newDevice->ff) FFReleaseDevice(newDevice->ff);
-    if (newDevice->elements) CFRelease(newDevice->elements);
+    if (This->ff) FFReleaseDevice(This->ff);
+    if (This->elements) CFRelease(This->elements);
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
-    release_DataFormat(&newDevice->generic.base.data_format);
-    HeapFree(GetProcessHeap(),0,newDevice->generic.name);
-    HeapFree(GetProcessHeap(),0,newDevice);
+    release_DataFormat(&This->generic.base.data_format);
+    HeapFree(GetProcessHeap(), 0, This->generic.name);
     return hr;
 }
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 87e91a21133..8fe469edbc3 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -37,6 +37,8 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
+    HRESULT (CDECL *init)(struct unix_joystick *ptr);
+
     HRESULT (CDECL *acquire)(struct unix_joystick *ptr);
     HRESULT (CDECL *unacquire)(struct unix_joystick *ptr);
 
-- 
2.28.0

>From a78c6e819ee36ef4e5f7f56c4f43d35315c559b6 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 15:02:39 +0200
Subject: [PATCH 24/39] dinput: Use the unix vtable for default axis mapping.

So that we can load the registry settings from Win32 side.
---
 dlls/dinput/joystick.c            |  47 ++++++++++----
 dlls/dinput/joystick_linux.c      | 101 ++++++++++++++----------------
 dlls/dinput/joystick_linuxinput.c | 100 ++++++++++++++++++-----------
 dlls/dinput/joystick_osx.c        |   6 +-
 dlls/dinput/joystick_private.h    |   5 +-
 5 files changed, 151 insertions(+), 108 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 8cf7ff05a0b..ec46b25c2cc 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1035,35 +1035,49 @@ DWORD joystick_map_pov(const POINTL *p)
  * Setup the dinput options.
  */
 
-HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_map)
+static char *string_wtoa(const WCHAR *strw)
+{
+    char *str;
+    int len;
+    if (!strw) return NULL;
+    len = WideCharToMultiByte(CP_ACP, 0, strw, -1, NULL, 0, NULL, NULL);
+    str = HeapAlloc(GetProcessHeap(), 0, len);
+    WideCharToMultiByte(CP_ACP, 0, strw, -1, str, len, NULL, NULL);
+    return str;
+}
+
+static HRESULT setup_dinput_options(JoystickGenericImpl *This, int default_axis_count, const int *default_axis_map)
 {
     char buffer[MAX_PATH+16];
     HKEY hkey, appkey;
     int tokens = 0;
     int axis = 0;
     int pov = 0;
+    char *name;
 
     get_app_key(&hkey, &appkey);
 
     /* get options */
 
-    if (!get_config_key(hkey, appkey, "DefaultDeadZone", buffer, sizeof(buffer)))
+    if (get_config_key(hkey, appkey, "DefaultDeadZone", buffer, sizeof(buffer))) This->deadzone = 0;
+    else
     {
         This->deadzone = atoi(buffer);
         TRACE("setting default deadzone to: \"%s\" %d\n", buffer, This->deadzone);
     }
 
-    This->axis_map = HeapAlloc(GetProcessHeap(), 0, This->device_axis_count * sizeof(int));
+    This->axis_map = HeapAlloc(GetProcessHeap(), 0, default_axis_count * sizeof(int));
     if (!This->axis_map) return DIERR_OUTOFMEMORY;
 
-    if (!get_config_key(hkey, appkey, This->name, buffer, sizeof(buffer)))
+    name = string_wtoa(This->base.info.tszProductName);
+    if (!get_config_key(hkey, appkey, name, buffer, sizeof(buffer)))
     {
         static const char *axis_names[] = {"X", "Y", "Z", "Rx", "Ry", "Rz",
                                            "Slider1", "Slider2",
                                            "POV1", "POV2", "POV3", "POV4"};
         const char *delim = ",";
         char * ptr;
-        TRACE("\"%s\" = \"%s\"\n", This->name, buffer);
+        TRACE("\"%s\" = \"%s\"\n", name, buffer);
 
         if ((ptr = strtok(buffer, delim)) != NULL)
         {
@@ -1113,11 +1127,10 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
                 tokens++;
             } while ((ptr = strtok(NULL, delim)) != NULL);
 
-            if (tokens != This->device_axis_count)
+            if (tokens != default_axis_count)
             {
-                ERR("not all joystick axes mapped: %d axes(%d,%d), %d arguments\n",
-                    This->device_axis_count, axis, pov, tokens);
-                while (tokens < This->device_axis_count)
+                ERR("not all joystick axes mapped: %d axes(%d,%d), %d arguments\n", default_axis_count, axis, pov, tokens);
+                while (tokens < default_axis_count)
                 {
                     This->axis_map[tokens] = -1;
                     tokens++;
@@ -1132,7 +1145,7 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
         if (default_axis_map)
         {
             /* Use default mapping from the driver */
-            for (i = 0; i < This->device_axis_count; i++)
+            for (i = 0; i < default_axis_count; i++)
             {
                 This->axis_map[i] = default_axis_map[i];
                 tokens = default_axis_map[i];
@@ -1151,7 +1164,7 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
         else
         {
             /* No config - set default mapping. */
-            for (i = 0; i < This->device_axis_count; i++)
+            for (i = 0; i < default_axis_count; i++)
             {
                 if (i < 8)
                     This->axis_map[i] = axis++;
@@ -1170,6 +1183,7 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
 
     if (appkey) RegCloseKey(appkey);
     if (hkey)   RegCloseKey(hkey);
+    HeapFree(GetProcessHeap(), 0, name);
 
     return DI_OK;
 }
@@ -1178,8 +1192,17 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
 {
     JoystickGenericImpl *This;
     HRESULT hr;
+    const int *default_axes_map;
+    int default_axis_count;
+
+    if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
+        return hr;
+    if (This->unix_funcs->get_mapping)
+    {
+        This->unix_funcs->get_mapping(This->unix_ptr, &default_axis_count, &default_axes_map);
+        if (FAILED(hr = setup_dinput_options(This, default_axis_count, default_axes_map))) goto done;
+    }
 
-    if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This))) return hr;
     if (FAILED(hr = This->unix_funcs->init(This->unix_ptr))) goto done;
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 873ee88c20c..48c1e4b433a 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -82,7 +82,7 @@ struct JoyDev
 
     BYTE axis_count;
     BYTE button_count;
-    int  *dev_axes_map;
+    int axes_map[ABS_MAX + 1];
 
     WORD vendor_id, product_id, bus_type;
 
@@ -139,10 +139,12 @@ static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_get_mapping,
     unix_joystick_acquire,
     unix_joystick_unacquire,
     NULL,
@@ -180,7 +182,7 @@ static BOOL read_sys_id_variable(int index, const char *property, WORD *value)
 
 static INT find_joystick_devices(void)
 {
-    INT i;
+    INT i, j;
 
     if (joystick_devices_count != -1) return joystick_devices_count;
 
@@ -237,7 +239,6 @@ static INT find_joystick_devices(void)
         }
         else
         {
-            INT j;
             /* in lieu of properly reporting HID usage, detect presence of
              * "joystick buttons" and report those devices as joysticks instead of
              * gamepads */
@@ -280,54 +281,50 @@ static INT find_joystick_devices(void)
         if (ioctl(fd, JSIOCGAXMAP, axes_map) < 0)
         {
             WARN("ioctl(%s,JSIOCGAXMAP) failed: %s\n", joydev.device, strerror(errno));
-            joydev.dev_axes_map = NULL;
+            for (j = 0; j < joydev.axis_count; j++)
+                joydev.axes_map[j] = j;
         }
         else
-            if ((joydev.dev_axes_map = HeapAlloc(GetProcessHeap(), 0, joydev.axis_count * sizeof(int))))
-            {
-                INT j, found_axes = 0;
+        {
+            INT found_axes = 0;
 
-                /* Remap to DI numbers */
-                for (j = 0; j < joydev.axis_count; j++)
+            /* Remap to DI numbers */
+            for (j = 0; j < joydev.axis_count; j++)
+            {
+                if (axes_map[j] < 8)
                 {
-                    if (axes_map[j] < 8)
-                    {
-                        /* Axis match 1-to-1 */
-                        joydev.dev_axes_map[j] = j;
-                        found_axes++;
-                    }
-                    else if (axes_map[j] <= 10)
-                    {
-                        /* Axes 8 through 10 are Wheel, Gas and Brake,
-                         * remap to 0, 1 and 2
-                         */
-                        joydev.dev_axes_map[j] = axes_map[j] - 8;
-                        found_axes++;
-                    }
-                    else if (axes_map[j] == 16 ||
-                             axes_map[j] == 17)
-                    {
-                        /* POV axis */
-                        joydev.dev_axes_map[j] = 8;
-                        found_axes++;
-                    }
-                    else
-                        joydev.dev_axes_map[j] = -1;
+                    /* Axis match 1-to-1 */
+                    joydev.axes_map[j] = j;
+                    found_axes++;
                 }
-
-                /* If no axes were configured but there are axes assume a 1-to-1 (wii controller) */
-                if (joydev.axis_count && !found_axes)
+                else if (axes_map[j] <= 10)
                 {
-                    int axes_limit = min(joydev.axis_count, 8); /* generic driver limit */
+                    /* Axes 8 through 10 are Wheel, Gas and Brake,
+                     * remap to 0, 1 and 2
+                     */
+                    joydev.axes_map[j] = axes_map[j] - 8;
+                    found_axes++;
+                }
+                else if (axes_map[j] == 16 || axes_map[j] == 17)
+                {
+                    /* POV axis */
+                    joydev.axes_map[j] = 8;
+                    found_axes++;
+                }
+                else joydev.axes_map[j] = -1;
+            }
 
-                    ERR("Incoherent joystick data, advertised %d axes, detected 0. Assuming 1-to-1.\n",
-                        joydev.axis_count);
-                    for (j = 0; j < axes_limit; j++)
-                        joydev.dev_axes_map[j] = j;
+            /* If no axes were configured but there are axes assume a 1-to-1 (wii controller) */
+            if (joydev.axis_count && !found_axes)
+            {
+                int axes_limit = min(joydev.axis_count, 8); /* generic driver limit */
 
-                    joydev.axis_count = axes_limit;
-                }
+                ERR("Incoherent joystick data, advertised %d axes, detected 0. Assuming 1-to-1.\n", joydev.axis_count);
+                for (j = 0; j < axes_limit; j++) joydev.axes_map[j] = j;
+
+                joydev.axis_count = axes_limit;
             }
+        }
 
         /* Find vendor_id and product_id in sysfs */
         joydev.vendor_id  = 0;
@@ -503,6 +500,13 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     return DI_OK;
 }
 
+static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    *axis_count = This->joydev->axis_count;
+    *axes_map = This->joydev->axes_map;
+}
+
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
@@ -510,8 +514,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     HRESULT hr;
     DWORD i, idx = 0;
 
-    This->generic.name = This->joydev->name;
-    This->generic.device_axis_count = This->joydev->axis_count;
     This->generic.devcaps.dwButtons = This->joydev->button_count;
 
     if (This->generic.devcaps.dwButtons > 128)
@@ -520,12 +522,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
         This->generic.devcaps.dwButtons = 128;
     }
 
-    /* setup_dinput_options may change these */
-    This->generic.deadzone = 0;
-
-    /* do any user specified configuration */
-    if (FAILED(hr = setup_dinput_options(&This->generic, This->joydev->dev_axes_map))) goto failed;
-
     /* Create copy of default data format */
     hr = DIERR_OUTOFMEMORY;
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
@@ -534,7 +530,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     df->dwNumObjs = This->generic.devcaps.dwAxes + This->generic.devcaps.dwPOVs + This->generic.devcaps.dwButtons;
     if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
 
-    for (i = 0; i < This->generic.device_axis_count; i++)
+    for (i = 0; i < This->joydev->axis_count; i++)
     {
         int wine_obj = This->generic.axis_map[i];
 
@@ -578,8 +574,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     This->generic.devcaps.dwFFDriverVersion = 0;
 
     if (TRACE_ON(dinput)) {
-        for (i = 0; i < (This->generic.device_axis_count); i++)
-            TRACE("axis_map[%d] = %d\n", i, This->generic.axis_map[i]);
+        for (i = 0; i < (This->joydev->axis_count); i++) TRACE("axis_map[%d] = %d\n", i, This->generic.axis_map[i]);
         _dump_DIDEVCAPS(&This->generic.devcaps);
     }
 
